[parted-devel] [PATCH 2/2] tests: test creating 20 device-mapper partitions (#803108)

Brian C. Lane bcl at redhat.com
Fri Apr 20 18:46:01 UTC 2012


From: "Brian C. Lane" <bcl at redhat.com>

* tests/t6002-dm-many-partitions.sh: Make sure > 17 partitions appear in
  device mapper.
---
 tests/Makefile.am                 |    1 +
 tests/t6002-dm-many-partitions.sh |   62 +++++++++++++++++++++++++++++++++++++
 2 files changed, 63 insertions(+), 0 deletions(-)
 create mode 100755 tests/t6002-dm-many-partitions.sh

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 1b37fd9..57771be 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -55,6 +55,7 @@ TESTS = \
   t5000-tags.sh \
   t6000-dm.sh \
   t6001-psep.sh \
+  t6002-dm-many-partitions.sh \
   t6100-mdraid-partitions.sh \
   t7000-scripting.sh \
   t8000-loop.sh \
diff --git a/tests/t6002-dm-many-partitions.sh b/tests/t6002-dm-many-partitions.sh
new file mode 100755
index 0000000..d57bce0
--- /dev/null
+++ b/tests/t6002-dm-many-partitions.sh
@@ -0,0 +1,62 @@
+#!/bin/sh
+# gpt: create many partitions
+# Before parted-3.1, this would provoke an invalid free.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../parted $srcdir
+
+require_root_
+
+# TODO: do something to require dmsetup
+
+ss=$sector_size_
+
+ns=300
+n_partitions=20
+start_sector=34
+loop_file=loop-file-$$
+dm_name=dm-test-$$
+
+cleanup_fn_() {
+    dmsetup remove $dm_name
+    test -n "$dev" && losetup -d "$dev"
+    rm -f $loop_file;
+}
+
+# TODO: make this error handling work better
+# create a file large enough to hold a GPT partition table
+dd if=/dev/null of=$loop_file bs=$ss seek=$ns || fail=1
+dev=$(loop_setup_ "$loop_file") || fail=1
+dmsetup create $dm_name --table "0 ($ss*$ns) linear $dev 0" || fail=1
+
+cmd=
+
+for ((i=1; i<=$n_partitions; i+=1)); do
+  s=$((start_sector + i - 1))
+  cmd="$cmd mkpart p$i ${s}s ${s}s"
+done
+parted -m -a min -s $dm_name mklabel gpt $cmd > /dev/null 2>&1 || fail=1
+
+# Make sure all the partitions appeared under /dev/mapper/$dm_name-$i
+for ((i=1; i<=$n_partitions; i+=1)); do
+    if [ ! -e "/dev/mapper/${dm_name}p$i" ]; then
+        fail=1
+        break
+    fi
+done
+
+Exit $fail
-- 
1.7.7.6




More information about the parted-devel mailing list